module.exports = {
    current: {server: "192.168.1.184", port: "60666"},
    local: {server: "localhost", port: "27017"},
    qa: {server: "192.168.1.184", port: "60666"},
    prod: {server: "", port: ""},
    setToLocalDb: function() {
        var me = this;
        me.current.server = me.local.server;
        me.current.port = me.local.port;
    },
    setToQaDb: function() {
        var me = this;
        me.current.server = me.qa.server;
        me.current.port = me.qa.port;
    },
    setToProdDb: function() {
        var me = this;
        me.current.server = me.prod.server;
        me.current.port = me.prod.port;
    }
}