/**
 * Created by Tony on 2017/3/13.
 */

let express = require('express');
let rptRouter = express.Router();
let reportController = require('./../controllers/rpt_controller');

module.exports =function (app) {

    app.get('/report',  function(req, res) {
        if (!req.session.userAccount) {
            res.redirect('/login');
        }
        else {
            res.render('maintain/report/rpt_test.html',
                {userAccount: req.session.userAccount,
                    userID: req.session.userID});
        }
    });
    rptRouter.post('/getReport', reportController.getReportAllPages);
    rptRouter.get('/getExcel/:id/:size/:rptName', reportController.getExcel);
    app.use("/report_api", rptRouter);
}
