/**
 * Created by vian on 2017/3/17.
 */
let express = require("express");
let billsController = require("./../controllers/bills_lib_controllers");
let billsRouter =express.Router();

module.exports =function (app) {

    app.get("/stdBillsmain", function(req, res){
        if(!req.session.userAccount){
            res.redirect('/login');
        }
        else {
            res.render("maintain/bills_lib/html/main.html",
                {userAccount: req.session.userAccount,
                    userID: req.session.userID});
        }
    });
    app.get("/stdBills", function(req, res){
        res.render("maintain/bills_lib/html/qingdan.html");
    });
    app.get('/stdJobs', function(req, res){
        res.render('maintain/bills_lib/html/neirong.html');
    });
    app.get('/stdItems', function(req, res){
        res.render('maintain/bills_lib/html/tezheng.html');
    });

    billsRouter.post('/getMaxNumber', billsController.getMaxNumber);
    billsRouter.post('/getABillsLib', billsController.getABillsLib);
    billsRouter.post("/getStdBillsLib", billsController.getStdBillsLib);
    billsRouter.post("/createStdBillsLib", billsController.createStdBillsLib);
    billsRouter.post("/upMove", billsController.upMove);
    billsRouter.post("/deleteStdBillsLib", billsController.deleteStdBillsLib);
    billsRouter.post("/renameStdBillsLib", billsController.renameStdBillsLib);
    billsRouter.post("/getStdBillsLibName", billsController.getStdBillsLibName);
    billsRouter.post("/getCurrentUniqId", billsController.getCurrentUniqId);
    billsRouter.post("/getBills", billsController.getBills);
    billsRouter.post("/createBills", billsController.createBills);
    billsRouter.post("/updatePNId", billsController.updatePNId);
    billsRouter.post("/updateBills", billsController.updateBills);
    billsRouter.post("/updateBillsArr", billsController.updateBillsArr);
    billsRouter.post("/pasteBills", billsController.pasteBills);
    billsRouter.post('/updateRecharge', billsController.updateRecharge);
    billsRouter.post('/pasteRel', billsController.pasteRel);
    billsRouter.post("/deleteBills", billsController.deleteBills);
    billsRouter.post("/getJobContent", billsController.getJobContent);
    billsRouter.post("/createJobContent", billsController.createJobContent);
    billsRouter.post("/updateJobContent", billsController.updateJobContent);
    billsRouter.post("/deleteJobContent", billsController.deleteJobContent);
    billsRouter.post("/pasteJobs", billsController.pasteJobs);
    billsRouter.post("/edCreateJob", billsController.edCreateJob);
    billsRouter.post("/edUpdateJob", billsController.edUpdateJob);
    billsRouter.post("/getItemCharacter", billsController.getItemCharacter);
    billsRouter.post("/createItemCharacter", billsController.createItemCharacter);
    billsRouter.post("/updateItemCharacter", billsController.updateItemCharacter);
    billsRouter.post("/updateValue", billsController.updateValue);
    billsRouter.post("/deleteItemCharacter", billsController.deleteItemCharacter);
    billsRouter.post("/pasteItems", billsController.pasteItems);
    billsRouter.post("/pasteValues", billsController.pasteValues);
    billsRouter.post("/edCreateItem", billsController.edCreateItem);
    billsRouter.post("/edUpdateItem", billsController.edUpdateItem);

    app.use("/stdBillsEditor", billsRouter);

}


