/**
 * Created by Tony on 2017/6/7.
 */
let JV = {
    NODE_CROSS_INFO: "交叉表_信息",
    NODE_CROSS_ROW: "交叉行",
    NODE_CROSS_COL: "交叉列",
    NODE_CROSS_CONTENT: "交叉数据",
    NODE_CROSS_ROW_SUM: "交叉行合计",
    NODE_CROSS_COL_SUM: "交叉列合计",
    NODE_CROSS_ROW_EXT: "交叉行拓展",
    NODE_CROSS_ROW_SUM_EXT: "交叉行拓展合计",
    NODE_FIELD_MAP: "指标_数据_映射",
    NODE_DISCRETE_FIELDS: "离散指标_集合",
    NODE_NO_MAPPING_FIELDS: "无映射离散指标_集合",
    NODE_DISCRETE_PARAMS: "离散参数_集合",
    NODE_MASTER_FIELDS: "主数据指标_集合",
    NODE_DETAIL_FIELDS: "从数据指标_集合",
    NODE_BAND_COLLECTION: "布局框_集合",
    NODE_FORMULAS: "计算式_集合",
    NODE_DISCRETE_INFO: "离散信息",
    NODE_BILL_INFO: "账单式表_信息",
    NODE_BILL_CONTENT : "账单式表_数据",
    NODE_FLOW_INFO: "流水式表_信息",
    NODE_FLOW_GROUP: "流水式表_分组信息",
    NODE_FLOW_SEG_SUM: "流水式表_段统计信息",
    NODE_FLOW_PAGE_SUM: "流水式表_页统计信息",
    NODE_FLOW_COLUMN : "流水式表_列",
    NODE_FLOW_CONTENT : "流水式表_数据",
    PROP_MULTI_COLUMN: "多列显示数量",

    NODE_MAIN_INFO: "主信息",
    NODE_MAIN_INFO_RPT_NAME: "报表名称",
    NODE_PAGE_INFO: "打印页面_信息",
    NODE_MARGINS: "页边距",

    NODE_FONT_COLLECTION: "font_collection",
    NODE_STYLE_COLLECTION: "style_collection",
    NODE_CONTROL_COLLECTION: "control_collection",

    PROP_ID: "ID",
    PROP_AD_HOC_DATA: "data_field",
    PROP_CMN_HEIGHT: "CommonHeight",
    PROP_CMN_WIDTH: "CommonWidth",
    PROP_BAND_NAME: "BandName",
    PROP_UNITS: "单位",
    PROP_PAGE_SIZE: "页规格",
    PROP_ORIENTATION: "方向",
    PROP_LEFT: "Left",
    PROP_RIGHT: "Right",
    PROP_TOP: "Top",
    PROP_BOTTOM: "Bottom",
    PROP_DATA_TYPE: "DataType",
    PROP_NAME: "Name",
    PROP_DFT_VALUE: "Default_Value",
    PROP_EXPRESSION: "expression",
    PROP_RUN_TYPE: "run_type",
    PROP_BORDER_STYLE: "border_style",
    PROP_POSITION: "Position",
    PROP_HIDDEN: "Hidden",
    PROP_IS_SERIAL: "isSerial",
    PROP_FONT: "font",
    PROP_CONTROL: "control",
    PROP_STYLE: "style",
    PROP_VALUE: "Value",
    PROP_LABEL: "Label",
    PROP_AREA: "area",
    PROP_DISCRETE_FIELDS: "discrete_field_s",
    PROP_FLOW_FIELDS: "flow_field_s",
    PROP_BILL_FIELDS: "bill_field_s",
    PROP_GROUP_FIELDS: "group_field_s",
    PROP_SUM_FIELDS: "sum_field_s",
    PROP_TEXTS: "text_s",
    PROP_TEXT: "text",
    PROP_FIELD_ID: "FieldID",
    PROP_PARAM_ID: "ParamID",
    PROP_PREFIX: "Prefix",
    PROP_SUFFIX: "Suffix",
    PROP_FORMAT: "Format",

    PROP_SHOW_ZERO: "ShowZero",
    PROP_EXTENSION_TYPE: "ExtType",

    PROP_CALCULATION: "CalculationType",
    PROP_H_CALCULATION: "H_CalculationType",
    PROP_V_CALCULATION: "V_CalculationType",

    IDX_LEFT: 0,
    IDX_TOP: 1,
    IDX_RIGHT: 2,
    IDX_BOTTOM: 3,

    BAND_PROP_NAME: "Name",
    BAND_PROP_MERGE_BAND: "MergeBand",
    BAND_PROP_STYLE: "style",
    BAND_PROP_CONTROL: "control",
    BAND_PROP_HEIGHT: "Height",
    BAND_PROP_WIDTH: "Width",
    BAND_PROP_DISPLAY_TYPE: "DisplayType",
    BAND_PROP_ALIGNMENT: "Alignment",
    BAND_PROP_MERGE_BORDER: "MergeBorder",
    BAND_PROP_SUB_BANDS: "band_s",

    MEASUREMENT: {
        PIXEL:["像素点", "象素点", "PIXEL"],
        CM: ["厘米", "CM"],
        INCH: ["英寸","INCH"]
    },

    PROP_IS_ID: "isID",
    PROP_ID_SEQ: "IDSeq",

    TAB_CROSS_FIELDS: "cross_field_s",
    TAB_FIELD_PROP_SORT: "Sort",
    TAB_FIELD_PROP_SORT_VAL_NOSORT: "no_sort",
    TAB_FIELD_PROP_SORT_VAL_ASC: "ascend",
    TAB_FIELD_PROP_SORT_VAL_DESC: "descend",

    DATA_DISCRETE_DATA: "discrete_data",
    DATA_MASTER_DATA: "master_data",
    DATA_DETAIL_DATA: "detail_data",

    BLANK_FIELD_INDEX: -10,
    BLANK_VALUE_INDEX: -100,
    BLANK_PAGE_VALUE_INDEX: -200,

    RUN_TYPE_BEFORE_PAGING: "before_paging",
    RUN_TYPE_BEFORE_OUTPUT: "before_output",

    PAGE_STATUS: ["EveryPage","FirstPage", "LastPage", "SegmentStart", "SegmentEnd", "Group", "CrossRowEnd", "CrossColEnd"],

    CONTROL_PROPS: ["Shrink", "ShowZero", "Horizon", "Vertical", "Wrap"],
    BORDER_STYLE_PROPS: ["LineWeight", "DashStyle", "Color"],
    PROP_LINE_WEIGHT: "LineWeight",
    PROP_DASH_STYLE: "DashStyle",
    PROP_COLOR: "Color",
    FONT_PROPS: ["Name", "FontHeight", "FontColor", "FontBold", "FontItalic", "FontUnderline", "FontStrikeOut", "FontAngle"],

    STATUS_NORMAL: 0,
    STATUS_REPORT_START: 1,
    STATUS_REPORT_END: 2,
    STATUS_SEGMENT_START: 3,
    STATUS_SEGMENT_END: 4,
    STATUS_GROUP: 5,
    STATUS_CROSS_ROW_END: 6,
    STATUS_CROSS_COL_END: 7,

    LAYOUT: ["Top","Bottom", "Left", "Right", "Fulfill"],
    LAYOUT_TOP: 0,
    LAYOUT_BOTTOM: 1,
    LAYOUT_LEFT: 2,
    LAYOUT_RIGHT: 3,
    LAYOUT_FULFILL: 4,

    OUTPUT_ALIGN: {
        H: ["Left", "Center", "Right"],
        V: ["Top", "Center", "Bottom"]
    },

    CAL_TYPE:["percentage","abstract"],
    CAL_TYPE_PERCENTAGE: 0,
    CAL_TYPE_ABSTRACT: 1,

    PAGE_ORIENTATION_V_FIRST: 0,
    PAGE_ORIENTATION_H_FIRST: 1,

    ORIENTATION_PORTRAIT: "PORTRAIT",
    ORIENTATION_LANDSCAPE: "LANDSCAPE",
    ORIENTATION_PORTRAIT_CHN: "纵",
    ORIENTATION_LANDSCAPE_CHN: "横",
    SIZE_A3: [11.69, 16.54],
    SIZE_A4: [8.27, 11.69],
    SIZE_A5: [5.83, 8.27],
    SIZE_B5: [6.93, 9.84],
    SIZE_LETTER: [8.5, 11.0],
    SIZE_LEGAL: [8.5, 14.0],
    SIZE_16K: [7.75, 10.75],
    SIZE_EXECUTIVE: [7.25, 10.5],

    OUTPUT_OFFSET: [2,1,2,3],
    OFFSET_IDX_LEFT: 0,
    OFFSET_IDX_RIGHT: 1,
    OFFSET_IDX_TOP: 2,
    OFFSET_IDX_BOTTOM: 3,

    PROP_PAGE_SEQ: "page_seq",

    PAGE_SELF_DEFINE: "自定义",

    PAGES_SIZE_STR: ["A3", "A4", "A5", "B5", "LETTER", "LEGAL", "EXECUTIVE", "16K"],
    PAGES_SIZE: [[11.69, 16.54], [8.27, 11.69], [5.83, 8.27], [6.93, 9.84], [8.5, 11.0], [8.5, 14.0], [7.25, 10.5], [7.25, 10.5]],

    HUNDRED_PERCENT : 100.0,

    VERTICAL_ANGLE: "90",
    ANTI_VERTICAL_ANGLE: "-90",

    LAST_DEF: ""
}
