let setting = {
    view: {
        addHoverDom: zTreeOprObj.addHoverDom,
        removeHoverDom: zTreeOprObj.removeHoverDom,
        expandSpeed: "",
        selectedMulti: false
    },
    edit: {
        enable: true,
        editNameSelectAll: true,
        showRemoveBtn: true,
        showRenameBtn: true,
        removeTitle: "删除节点",
        renameTitle: "更改名称"
    },
    data: {
        keep: {
            parent:true,
            leaf:true
        },
        key: {
            children: "items"
        },
        simpleData: {
            enable: true,
            idKey: "ID",
            pIdKey: "ParentID",
            rootPId: -1
        }
    },
    callback:{
        onClick: zTreeOprObj.onClick,
        beforeRename: zTreeOprObj.beforeRename,
        beforeRemove: zTreeOprObj.onBeforeRemove,
        onRemove: zTreeOprObj.onRemove,
        onRename: zTreeOprObj.onRename
    }
};

let common_rpt_type_ids = {
    flow: 4,
    bill: 6,
    cross: 5
};

let bandSetting = {
    view: {
        showIcon: true,
        expandSpeed: "",
        selectedMulti: false
    },
    edit: {
        enable: true,
        editNameSelectAll: true,
        showRemoveBtn: false,
        showRenameBtn: true,
        //removeTitle: "删除节点",
        renameTitle: "更改名称"
    },
    data: {
        keep: {
            parent:true,
            leaf:true
        },
        key: {
            children: 'band_s',
            name: "Name"
        },
        simpleData: {
            enable: true
            //,idKey: "ID",
            //pIdKey: "ParentID",
            //rootPId: -1
        }
    },
    callback:{
        onClick: bandTreeOprObj.onClick
    }
};

let fieldMapSetting = {
    view: {
        showIcon: true,
        expandSpeed: "",
        selectedMulti: false
    },
    edit: {
        enable: true,
        editNameSelectAll: true,
        showRemoveBtn: true,
        showRenameBtn: false,
        removeTitle: "删除",
        renameTitle: "更改名称",
        drag: {
            isCopy: false,
            isMove: true
        }
    },
    data: {
        keep: {
            parent:true,
            leaf:true
        },
        key: {
            children: 'items',
            name: "Name"
        },
        simpleData: {
            enable: true
        }
    },
    callback:{
        onClick: fieldMapTreeOprObj.onClick,
        beforeRename: fieldMapTreeOprObj.beforeRename,
        beforeRemove: fieldMapTreeOprObj.onBeforeRemove,
        onRemove: fieldMapTreeOprObj.onRemove,
        onRename: fieldMapTreeOprObj.onRename,
        beforeDrop: fieldMapTreeOprObj.onBeforeDrop
    }
};

let selectableFieldSetting = {
    view: {
        showIcon: true,
        expandSpeed: "",
        selectedMulti: false
        //,addDiyDom: selectableFiledTreeOprObj.addDiyDom
    },
    edit: {
        enable: true,
        editNameSelectAll: false,
        showRemoveBtn: false,
        showRenameBtn: false,
        removeTitle: "删除",
        renameTitle: "更改名称",
        drag: {
            isCopy: true,
            isMove: false
        }
    },
    data: {
        keep: {
            parent:true,
            leaf:true
        },
        key: {
            children: 'items',
            name: "Name"
        },
        simpleData: {
            enable: true
        }
    },
    callback:{
        onClick: selectableFiledTreeOprObj.onClick,
        beforeDrag: selectableFiledTreeOprObj.onBeforeDrag,
        beforeDrop: selectableFiledTreeOprObj.onBeforeDrop
    }
};
